      program PAPn03d

c     In PAPn03d, a Mendelian model (y = m + g + e) is
c     assumed and the trait is treated as a discrete
c     variable.

      include 'PAPn03d.inc'
      integer tvis,gtp(mx_ind),pd_gtp(mx_ind,0:2),flag(0:2)
     >       ,pid(mx_ind,2),row(mx_nze),col(mx_nze)
     >       ,lev(mx_obs),ptp(mx_obs)
      real*8 a,d,ve,frq1,tvds1,tvds2,t(0:mx_ptp),lbt(mx_obs)
     >      ,lmin(0:mx_ptp-1),lmax(0:mx_ptp-1),g(0:2)
     >      ,b(0:mx_lev-1),ainv(mx_nze)
      open(99,file='pdgr.txt')
*     open(98,file='pdgr1.out')
      open(98,file='pdgr2.out')
      open(97,file='pdgr3.out')
*     open(95,file='pdgr4.out')
      open(96,file='phtp.txt')
      open(95,file='outp1.txt')
      open(94,file='outp2.txt')
      write(*,*) 'Please input the no. of total cycles.'
      read(*,*) nr_ccl
      write(*,*) 'Please input the no. of burn-in cycles.'
      read(*,*) nr_brn
      write(*,*) 'MCMC samples are stored in every x'
      write(*,*) 'cycles. Please input x.'
      read(*,*) nr_itv  ! itv means 'interval'.
      write(*,*) 'Please input a random seed.'
      read(*,*) n_seed
*     n_seed=1
      write(*,*) 'Please input the risk allele frequency.'
      read(*,*) ds_frq
      write(*,*) 'Please input the penetrances of WW, WR,'
      write(*,*) 'and RR.'
      read(*,*) pntr0,pntr1,pntr2
      prvl=((1.d0-ds_frq)**2)*pntr0
     >    +(2.d0*ds_frq*(1.d0-ds_frq))*pntr1
     >    +(ds_frq**2)*pntr2

      nr_ind=1
      nr_fdr=0
1     read(99,*,end=2) pid(nr_ind,1),pid(nr_ind,2)
      if(pid(nr_ind,1).eq.0.and.pid(nr_ind,2).eq.0)
     >   nr_fdr=nr_fdr+1
      nr_ind=nr_ind+1
      goto 1
2     continue
      nr_ind=nr_ind-1

      tvis=1
3     read(98,*,end=4) row(tvis),col(tvis),ainv(tvis)
      tvis=tvis+1
      goto 3
4     continue

      n_nzel(0)=0
      do i=1,nr_ind
       read(97,*) n_nzel(i)
       n_nzel(i)=n_nzel(i)+n_nzel(i-1)
      enddo

c     Phenotypic values must be sorted in order of ID.

      nr_obs(-1)=1
      nr_lev=-1  ! lev can be 0.
      nr_ptp=-1  ! Phenotypes can be 0 (normal).
      do i=0,mx_ptp-1
       nr_obs(i)=0
      enddo
      do i=0,nr_ind
       n_rcrd(i)=0
      enddo
5     read(96,*,end=6) tvis,lev(nr_obs(-1)),ptp(nr_obs(-1))
      n_rcrd(tvis)=n_rcrd(tvis)+1
      nr_obs(ptp(nr_obs(-1)))=nr_obs(ptp(nr_obs(-1)))+1
      if(lev(nr_obs(-1)).gt.nr_lev) nr_lev=lev(nr_obs(-1))
      if(ptp(nr_obs(-1)).gt.nr_ptp) nr_ptp=ptp(nr_obs(-1))
      nr_obs(-1)=nr_obs(-1)+1
      goto 5
6     continue
      nr_obs(-1)=nr_obs(-1)-1
      nr_lev=nr_lev+1
      nr_ptp=nr_ptp+1

      do i=2,nr_ind
       n_rcrd(i)=n_rcrd(i)+n_rcrd(i-1)
      enddo

      do i=1,nr_ind
       do j=0,2
        pd_gtp(i,j)=0
       enddo
      enddo

c     -----------------------------------------

      ve=1.d0
      call i_t(t)
      call i_l(lbt,t,lmin,lmax,ptp)
      call i_frq(frq1)
      call i_gtp(gtp)
      call i_g(g,flag,lbt)
      call i_b(b)
*     call i_u(u)
*     call i_vu(vu,lbt)
      do i=1,nr_ccl
       call s_t(t,lmin,lmax)
       call s_l(lbt,ve,t,lmin,lmax,gtp,g,b,lev,ptp)
*      call s_l(lbt,ve,t,lmin,lmax,gtp,g,b,u,lev,ptp)
       call s_frq(frq1,gtp,pid)
       call s_gtp(gtp,ve,frq1,lbt,g,b,pid,row,col,ainv,lev)
*      call s_gtp(gtp,ve,frq1,lbt,g,b,u,pid,row,col,ainv,lev)
       call s_g(g,flag,ve,frq1,lbt,gtp,b,lev)
*      call s_g(g,flag,ve,frq1,lbt,gtp,b,u,lev)
       call s_b(b,ve,lbt,gtp,g,lev)
*      call s_b(b,ve,lbt,gtp,g,u,lev)
*      call s_u(u,vu,ve,lbt,gtp,g,b,row,col,ainv,lev)
*      call s_vu(vu,u,row,col,ainv)
*      call s_ve(ve,gtp,g,b,u,lev,ptv)

       if(i.gt.nr_brn.and.mod(i,nr_itv).eq.0) then
        write(*,'(i10)') i
        tvds1=.0d0
        do j=1,nr_ind
         do k=n_rcrd(j-1)+1,n_rcrd(j)
          tvds1=tvds1
     >        -dlog(sqrt(2.d0*3.1415926535897932d0*ve))
     >        -.5d0*((lbt(k)-g(gtp(j))-b(lev(k)))**2)/ve
         enddo
        enddo
        if(flag(0)+flag(1)+flag(2).eq.1) then
         if(flag(0).eq.1) tvds2=g(0)
         if(flag(1).eq.1) tvds2=g(1)
         if(flag(2).eq.1) tvds2=g(2)
         write(95,'(6f16.8,3i2,4f16.8)') tvds2
     >       ,(b(j),j=0,nr_lev-1),.0d0,.0d0,frq1
     >       ,(flag(j),j=0,2),ve,(t(j),j=1,nr_ptp-1),tvds1
        elseif(flag(0)+flag(1)+flag(2).eq.2) then
         if(flag(0)+flag(1).eq.2) then
          tvds2=g(0)
          a=g(1)-g(0)
         elseif(flag(0)+flag(2).eq.2) then
          tvds2=.5d0*(g(0)+g(2))
          a=.5d0*(g(2)-g(0))
         else
          tvds2=g(1)
          a=g(2)-g(1)
         endif
         write(95,'(6f16.8,3i2,4f16.8)') tvds2
     >       ,(b(j),j=0,nr_lev-1),a,.0d0,frq1
     >       ,(flag(j),j=0,2),ve,(t(j),j=1,nr_ptp-1),tvds1
        else
         a=.5d0*(g(2)-g(0))
         d=g(1)-.5d0*(g(0)+g(2))
         write(95,'(6f16.8,3i2,4f16.8)') .5d0*(g(0)+g(2))
     >       ,(b(j),j=0,nr_lev-1),a,d,frq1
     >       ,(flag(j),j=0,2),ve,(t(j),j=1,nr_ptp-1),tvds1
        endif

        do j=1,nr_ind
         pd_gtp(j,gtp(j))=pd_gtp(j,gtp(j))+1
        enddo
       endif
      enddo
      do i=1,nr_ind
       write(94,'(3f16.8)') (dble(pd_gtp(i,j))
     >     /(dble(nr_ccl-nr_brn)/nr_itv),j=0,2)
      enddo

      stop
      end

c     ########################################

      subroutine i_t(t)

      include 'PAPn03d.inc'
      real*8 rand,tvds1,tvds2,t(0:mx_ptp)

      t(0)=-99.d0
      tvds1=1.d0-prvl
      call c_sndi(tvds1,rand)
      t(1)=rand
      write(*,*) t(1)
*     t(1)=-1.95548106803823d0  ! normsinv(24/950)
*     t(2)=1.03417869624299d0  ! normsinv((24+783)/950)
*     tvds1=.0d0
*     do i=1,nr_ptp-1
*      tvds1=tvds1+dble(nr_obs(i-1))/dble(nr_obs(-1))
*      tvds2=tvds1
*      call c_sndi(tvds2,rand)
*      t(i)=rand
*      write(*,*) t(i)
*     enddo

c     t(1) is fixed so that RAF = 0.0005 and penetrances
c     P_WW, P_WR, and P_RR are 0.0001, 0.9999, and 0.9999,
c     respectively.

*     t(1)=3.06193662103349d0
      t(nr_ptp)=99.d0

      return
      end

c     ########################################

      subroutine i_l(lbt,t,lmin,lmax,ptp)

      include 'PAPn03d.inc'
      integer ptp(mx_obs)
      real*8 normd,t(0:mx_ptp),lbt(mx_obs)
     >      ,lmin(0:mx_ptp-1),lmax(0:mx_ptp-1)

      do i=0,nr_ptp-1
       lmin(i)=99.d0
       lmax(i)=-99.d0
      enddo

      do i=1,nr_obs(-1)
11     lbt(i)=normd(n_seed)
       if(lbt(i).lt.t(ptp(i)).or.
     >    lbt(i).gt.t(ptp(i)+1)) goto 11
       if(lbt(i).lt.lmin(ptp(i))) lmin(ptp(i))=lbt(i)
       if(lbt(i).gt.lmax(ptp(i))) lmax(ptp(i))=lbt(i)
      enddo

      return
      end

c     ########################################

      subroutine i_frq(frq1)

      include 'PAPn03d.inc'
      real*8 frq1

      frq1=ds_frq
*     frq1=.5d0

      return
      end

c     ########################################

      subroutine i_gtp(gtp)

      include 'PAPn03d.inc'
      integer gtp(mx_ind)

      do i=1,nr_ind
       gtp(i)=1
      enddo

      return
      end

c     ########################################

      subroutine i_g(g,flag,lbt)

      include 'PAPn03d.inc'
      integer flag(0:2)
      real*8 sum,lbt(mx_obs),g(0:2)
      common/var2/sum

      sum=.0d0
      do i=1,nr_obs(-1)
       sum=sum+lbt(i)
      enddo
      do i=0,2
       g(i)=sum/dble(nr_obs(-1))
       flag(i)=0
      enddo
      flag(1)=1  ! All individuals are heterozygous.

      return
      end

c     ########################################

      subroutine i_b(b)

      include 'PAPn03d.inc'
      real*8 b(0:mx_lev-1)

      do i=0,nr_lev-1
       b(i)=.0d0
      enddo

      return
      end

c     ########################################

      subroutine s_t(t,lmin,lmax)

      include 'PAPn03d.inc'
      real*8 rand,t(0:mx_ptp),lmin(0:mx_ptp-1)
     >      ,lmax(0:mx_ptp-1)

*     do i=1,nr_ptp-1
*      call r_uni(rand,n_seed)
*      t(i)=lmax(i-1)+(lmin(i)-lmax(i-1))*rand
*     enddo
*     t(1)=3.06193662103349d0
*     t(1)=3.71901648545571d0  ! t is fixed (normsinv(1.d-4))

      return
      end

c     ########################################

      subroutine s_l(lbt,ve,t,lmin,lmax,gtp,g,b,lev,ptp)

      include 'PAPn03d.inc'
      integer gtp(mx_ind),lev(mx_obs),ptp(mx_obs)
      real*8 ve,normd,t(0:mx_ptp),lbt(mx_obs)
     >      ,lmin(0:mx_ptp-1),lmax(0:mx_ptp-1),g(0:2)
     >      ,b(0:mx_lev-1)

      do i=1,nr_ind
       do j=n_rcrd(i-1)+1,n_rcrd(i)
21      lbt(j)=g(gtp(i))+b(lev(j))
     >        +sqrt(ve)*normd(n_seed)
        if(lbt(j).lt.t(ptp(j)).or.
     >     lbt(j).gt.t(ptp(j)+1)) goto 21
        if(lbt(j).lt.lmin(ptp(j))) lmin(ptp(j))=lbt(j)
        if(lbt(j).gt.lmax(ptp(j))) lmax(ptp(j))=lbt(j)
       enddo
      enddo

      return
      end

c     ########################################

      subroutine s_frq(frq1,gtp,pid)

      include 'PAPn03d.inc'
      integer tvis,gtp(mx_ind),pid(mx_ind,2)
      real*8 frq1,tunp,rand,tvds1,tvds2,tvds3

      tunp=.1d0

      frq1=.0d0
      tvis=0
      do i=1,nr_ind
       if(pid(i,1).eq.0.and.pid(i,2).eq.0) then
        frq1=frq1+dble(gtp(i))
        tvis=tvis+gtp(i)
       endif
      enddo
      frq1=frq1/dble(2*nr_fdr)
      if(frq1.lt.1.d-4) frq1=1.d-4
      if(frq1.gt..9999d0) frq1=.9999d0

61    call r_uni(rand,n_seed)
      tvds1=frq1+(rand-.5d0)*tunp
      if(tvds1.lt..0d0.or.tvds1.gt.1.d0) goto 61
      tvds2=dble(tvis)*dlog(tvds1/frq1)
     >     +dble(2*nr_fdr-tvis)
     >     *dlog((1.d0-tvds1)/(1.d0-frq1))
      if(tvds2.gt..0d0) then
       tvds3=1.d0
       goto 62
      elseif(tvds2.lt.-256.d0) then
       tvds3=.0d0
       goto 62
      endif
      tvds3=dexp(tvds2)

62    continue
      call r_uni(rand,n_seed)
      if(rand.lt.tvds3) frq1=tvds1
      frq1=ds_frq  ! frq1 is fixed to a specified value.
*     frq1=5.d-4

      return
      end

c     ########################################

      subroutine s_gtp(gtp,ve,frq1,lbt,g,b,pid,row,col
     >                ,ainv,lev)

      include 'PAPn03d.inc'
      integer tvis,gtp(mx_ind),pid(mx_ind,2),row(mx_nze)
     >       ,col(mx_nze),lev(mx_obs)
      real*8 ve,frq1,tot_prb,rand,tvds,lbt(mx_obs),g(0:2)
     >      ,b(0:mx_lev-1),ainv(mx_nze),prb(0:2)

      do i=1,nr_ind
       if(pid(i,1).eq.0.and.pid(i,2).eq.0) then  ! Founder
        prb(0)=(1.d0-frq1)**2
        prb(1)=2.d0*frq1*(1.d0-frq1)
        prb(2)=frq1**2
       elseif(pid(i,1).ne.0.and.
     >        pid(i,2).ne.0) then  ! Non-founder
        if(gtp(pid(i,1)).ne.1.and.
     >     gtp(pid(i,2)).ne.1) then
         gtp(i)=(gtp(pid(i,1))+gtp(pid(i,2)))/2
         goto 31
        elseif((gtp(pid(i,1)).eq.0.and.
     >          gtp(pid(i,2)).eq.1).or.
     >         (gtp(pid(i,1)).eq.1.and.
     >          gtp(pid(i,2)).eq.0)) then
         prb(0)=.5d0
         prb(1)=.5d0
         prb(2)=.0d0
        elseif((gtp(pid(i,1)).eq.1.and.
     >          gtp(pid(i,2)).eq.2).or.
     >         (gtp(pid(i,1)).eq.2.and.
     >          gtp(pid(i,2)).eq.1)) then
         prb(0)=.0d0
         prb(1)=.5d0
         prb(2)=.5d0
        else
         prb(0)=.25d0
         prb(1)=.5d0
         prb(2)=.25d0
        endif
       else  ! Half-founder
        if(pid(i,1).eq.0) tvis=pid(i,2)
        if(pid(i,2).eq.0) tvis=pid(i,1)
        if(gtp(tvis).eq.0) then
         prb(0)=(1.d0-frq1)**2+frq1*(1.d0-frq1)
         prb(1)=frq1*(1.d0-frq1)+frq1**2
         prb(2)=.0d0
        elseif(gtp(tvis).eq.1) then
         prb(0)=.5d0*((1.d0-frq1)**2+frq1*(1.d0-frq1))
         prb(1)=.5d0
         prb(2)=.5d0*(frq1*(1.d0-frq1)+frq1**2)
        else
         prb(0)=.0d0
         prb(1)=(1.d0-frq1)**2+frq1*(1.d0-frq1)
         prb(2)=frq1*(1.d0-frq1)+frq1**2
        endif
       endif

       do j=n_nzel(i-1)+1,n_nzel(i)
        if(row(j).ne.col(j)) then
         if(pid(col(j),1).ne.i.and.
     >      pid(col(j),2).ne.i) goto 32  ! Parent or spouse
         if(pid(col(j),1).eq.i)
     >      tvis=pid(col(j),2)
         if(pid(col(j),2).eq.i)
     >      tvis=pid(col(j),1)

         if(tvis.ne.0) then
          if(gtp(col(j)).eq.0) then
           prb(2)=.0d0
           if(gtp(tvis).eq.0) then
            prb(1)=prb(1)*.5d0
           else
            prb(0)=prb(0)*.5d0
            prb(1)=prb(1)*.25d0
           endif
          elseif(gtp(col(j)).eq.1) then
           prb(1)=prb(1)*.5d0
           if(gtp(tvis).eq.0) then
            prb(0)=.0d0
           elseif(gtp(tvis).eq.1) then
            prb(0)=prb(0)*.5d0
            prb(2)=prb(2)*.5d0
           else
            prb(2)=.0d0
           endif
          else
           prb(0)=.0d0
           if(gtp(tvis).eq.1) then
            prb(1)=prb(1)*.25d0
            prb(2)=prb(2)*.5d0
           else
            prb(1)=prb(1)*.5d0
           endif
          endif
         else
          if(gtp(col(j)).eq.0) then
           prb(0)=prb(0)*((1.d0-frq1)**2+frq1*(1.d0-frq1))
           prb(1)=prb(1)*.5d0
     >           *((1.d0-frq1)**2+frq1*(1.d0-frq1))
           prb(2)=.0d0
          elseif(gtp(col(j)).eq.1) then
           prb(0)=prb(0)*(frq1*(1.d0-frq1)+frq1**2)
           prb(1)=prb(1)*.5d0
           prb(2)=prb(2)*((1.d0-frq1)**2+frq1*(1.d0-frq1))
          else
           prb(0)=.0d0
           prb(1)=prb(1)*.5d0*(frq1*(1.d0-frq1)+frq1**2)
           prb(2)=prb(2)*(frq1*(1.d0-frq1)+frq1**2)
          endif
         endif
        endif
32      continue
       enddo

       do j=n_rcrd(i-1)+1,n_rcrd(i)
        do k=0,2
         tvds=dlog(1.d0/sqrt(ve))
     >       -.5d0*((lbt(j)-g(k)-b(lev(j)))**2)/ve
         prb(k)=prb(k)*exp(tvds)
*        if(tvds.lt.-64.d0) then
*         prb(k)=.0d0
*        else
*         prb(k)=prb(k)*exp(tvds)
*        endif
        enddo
       enddo

       tot_prb=prb(0)+prb(1)+prb(2)
       prb(0)=prb(0)/tot_prb
       prb(1)=prb(1)/tot_prb
       call r_uni(rand,n_seed)
       if(rand.le.prb(0)) then
        gtp(i)=0
       elseif(rand.gt.prb(0).and.rand.le.prb(0)+prb(1)) then
        gtp(i)=1
       else
        gtp(i)=2
       endif
31     continue
      enddo

      return
      end

c     ########################################

      subroutine s_g(g,flag,ve,frq1,lbt,gtp,b,lev)

      include 'PAPn03d.inc'
      integer tvis1,tvis2,gtp(mx_ind),flag(0:2),lev(mx_obs)
      real*8 ve,frq1,normd,tvds,lbt(mx_obs),g(0:2)
     >      ,b(0:mx_lev-1),tvdm(0:2,2)

      do i=0,2
       tvdm(i,1)=.0d0
       tvdm(i,2)=.0d0
      enddo
      do i=1,nr_ind
       do j=n_rcrd(i-1)+1,n_rcrd(i)
        tvdm(gtp(i),1)=tvdm(gtp(i),1)+lbt(j)-b(lev(j))
        tvdm(gtp(i),2)=tvdm(gtp(i),2)+1.d0
       enddo
      enddo

c     -----------------------------------------

      do i=0,2
       if(tvdm(i,2).lt..5d0) flag(i)=0
       if(tvdm(i,2).gt..5d0) flag(i)=1
      enddo
51    if(flag(0).ne.0) then
       g(0)=.0d0  ! g(0) is fixed to 0.
       do i=1,2
        if(flag(i).ne.0) then
         g(i)=(tvdm(i,1)/tvdm(i,2))+sqrt(ve/tvdm(i,2))
     >       *normd(n_seed)
        else
         g(i)
     >  =(tvdm(0,1)+tvdm(1,1)+tvdm(2,1))/dble(nr_obs(-1))
     >  +sqrt(ve/dble(nr_obs(-1)))*normd(n_seed)
        endif
       enddo
      else
       g(0)
     >=(tvdm(0,1)+tvdm(1,1)+tvdm(2,1))/dble(nr_obs(-1))
     >+sqrt(ve/dble(nr_obs(-1)))*normd(n_seed)
       if(flag(1).ne.0.and.flag(2).ne.0) then
        g(1)=.0d0
        g(2)=(tvdm(2,1)/tvdm(2,2))+sqrt(ve/tvdm(2,2))
     >      *normd(n_seed)
       else
        if(flag(1).ne.0) i=1
        if(flag(2).ne.0) i=2
        g(i)=.0d0
        g(3-i)
     > =(tvdm(0,1)+tvdm(1,1)+tvdm(2,1))/dble(nr_obs(-1))
     > +sqrt(ve/dble(nr_obs(-1)))*normd(n_seed)
       endif
      endif

      tvis1=0
      if(flag(0)+flag(1)+flag(2).gt.1) then
       if(flag(0)+flag(2).gt.1) then
        if(g(0).gt.g(2)) tvis1=1
       elseif(flag(2).ne.1) then
        if(g(0).gt.g(1)) tvis1=1
       else
        if(g(1).gt.g(2)) tvis1=1
       endif
      else
       if(flag(2).ne.1) tvis1=1
      endif
      if(tvis1.ne.0) then
       tvis2=flag(0)
       flag(0)=flag(2)
       flag(2)=tvis2
       frq1=1.d0-frq1
       do i=1,nr_ind
        gtp(i)=2-gtp(i)
       enddo
       do i=1,2
        tvds=tvdm(0,i)
        tvdm(0,i)=tvdm(2,i)
        tvdm(2,i)=tvds
       enddo
       goto 51
      endif
*     if(g(0).gt.g(2)) goto 51

      return
      end

c     ########################################

      subroutine s_b(b,ve,lbt,gtp,g,lev)

      include 'PAPn03d.inc'
      integer gtp(mx_ind),lev(mx_obs)
      real*8 ve,normd,lbt(mx_obs),g(0:2),b(0:mx_lev-1)
     >      ,tvdm(0:mx_lev-1,2)

      do i=0,nr_lev-1
       tvdm(i,1)=.0d0
       tvdm(i,2)=.0d0
      enddo
      do i=1,nr_ind
       do j=n_rcrd(i-1)+1,n_rcrd(i)
        tvdm(lev(j),1)=tvdm(lev(j),1)+lbt(j)-g(gtp(i))
        tvdm(lev(j),2)=tvdm(lev(j),2)+1.d0
       enddo
      enddo
      do i=1,nr_lev-1  ! b(0) is fixed to 0.
       b(i)=(tvdm(i,1)/tvdm(i,2))+sqrt(ve/tvdm(i,2))
     >     *normd(n_seed)
       b(i)=.0d0  ! b is disregarded.
      enddo

      return
      end

c     ########################################

      subroutine r_uni(z,tan)
      integer l,c,t30,tan
      real*8 mu,z
      parameter(l=843314861,c=453816693,t30=2**30,
     >          mu=2.0**31)

      tan=l*tan+c
      if(tan.lt.0) tan=(tan+t30)+t30
      z=dble(tan)/mu
      return
      end

c     ########################################

      subroutine r_gam(rand,df)

      include 'PAPn03d.inc'
      real*8 df,c1,c2,z,v,u,rand,normd

      c1=df-1.d0/3.d0
      c2=1.d0/sqrt(9.d0*c1)

41    z=normd(n_seed)
      if(c2*z.le.-1.d0) goto 41
      v=(1.d0+c2*z)**3

      call r_uni(u,n_seed)
      if((u.lt.1.d0-.0331d0*(z**4)).or.
     >   (dlog(u).lt..5d0*(z**2)+c1*(1.d0-v+dlog(v)))) then
       rand=2.d0*c1*v  ! c1*v is multiplied by 2 (beta).
      else
       goto 41
      endif

      return
      end

c     ########################################

      subroutine c_sndi(rand1,rand2)

      real*8 rand1,rand2,c(0:512)

      rand1=2.d0*rand1-1.d0
      c(0)=1.d0
      do i=1,256  ! k is set to 256.
       c(i)=.0d0
       do j=0,i-1
        c(i)=c(i)+c(j)*c(i-1-j)
     >      /(dble(j+1)*dble(2*j+1))
       enddo
      enddo

      rand2=.0d0
      do i=0,256
       rand2=rand2+(c(i)/dble(2*i+1))
     >      *((sqrt(3.1415926535897932d0)*rand1/2.d0)
     >      **(2*i+1))
      enddo
      rand2=sqrt(2.d0)*rand2

      return
      end
