c-----------------------------------------------------c
c   calculate inbreeding                              c
c         written by Takayuki Ibi                     c
c                      08/10,1995                     c
c         modify       08/18,1995                     c
c         modify       08/28,1995                     c
c         modify       01/11,2000                     c
c  perameter                                          c
c   ngene  ;number of generation you want to trace    c
c   cfile;ketto file name (sorted in the small order) c
c   sfile;sfile name                                  c
c   out  ;inbreeding result file name                 c
c-----------------------------------------------------c
      parameter (n=5000000,nk=500000)
      integer id(3,n),key2(3,nk),pick(3,nk),key3(3,nk)
      integer temp(3)
      real*8 u(0:nk),v(0:nk),av,sd,f
      character cfile*40,sfile*40,out*40
      common /pinf/id,nrec,pick,ll
      write(*,*) 'input generation'
      read(*,*) ngene
      write(*,*) 'input ketto file'
      read(*,*) cfile
      write(*,*) 'input sfile'
      read(*,*) sfile
      write(*,*) 'input result file'
      read(*,*) out
      open(1,file=cfile)
      open(2,file=sfile)
      open(3,file=out)
      nrec=1
10    read(1,'(3i10)',end=777) id(1,nrec),id(2,nrec),id(3,nrec)
      nrec=nrec+1
      go to 10
777   close(1)
      ns=0
      av=0.0
      sd=0.0
20    read(2,'(i10)',end=999) ind
      ll=0
      nn=0
      call search(ind)
      ns=ns+1
      do 30 ii=2,ngene+1
        l=nn+1
        nn=ll
        do 40 jj=l,nn
        if(pick(2,jj).ne.0) then
        call search(pick(2,jj))
        end if
        if(pick(3,jj).ne.0) then
        call search(pick(3,jj))
        end if
40      continue
30    continue
      ncon=0
      do 50 kk=ll,1,-1
       if(pick(1,kk).ne.0) then
        ncon=ncon+1
        do 51 i=1,3
         key3(i,ncon)=pick(i,kk)
51      continue
       end if
50    continue
      i=ncon
52    if(i.lt.0) go to 888
       do 53 j=ncon,i+1,-1
        do 54 k=2,3
         if(key3(k,i).eq.0) go to 54
         if(key3(k,i).eq.key3(1,j)) then
          do 55 l=1,3
           temp(l)=key3(l,j)
           do 56 m=j-1,i,-1
           key3(l,m+1)=key3(l,m)
56         continue
           key3(l,i)=temp(l)
55       continue
         i=i+1
         go to 52
        end if
54     continue
53    continue
      i=i-1
      go to 52
888   continue
      do 70 j=1,ncon
       key2(1,j)=j
       key2(2,j)=0
       key2(3,j)=0
        do 71 jk=1,j
          if(key3(2,j).eq.key3(1,jk)) then
            key2(2,j)=jk
          end if
          if(key3(3,j).eq.key3(1,jk)) then
            key2(3,j)=jk
          end if
71      continue
70    continue
      v(0)=0.0
      u(0)=0.0
      do 100 k=1,ncon
       u(k)=0.0
100   continue
      do 80 i=1,ncon
       do 90 j=i,ncon
          ks=key2(2,j)
          kd=key2(3,j)
        if(i.eq.j) then
          v(j)=sqrt(1-(u(ks)+u(kd))/4)
        else
          if(ks.lt.i) then
           ks=0
          end if
          if(kd.lt.i) then
           kd=0
          end if
          v(j)=0.5*(v(ks)+v(kd))
         end if
          u(j)=u(j)+v(j)*v(j)
90      continue
80    continue
      f=u(ncon)-1.0
      av=av+f
      sd=sd+f*f
      write(3,'(f16.8)') f
*     write(3,'(i10,1x,f10.8)') ind,f
      go to 20
999   close(2)
      av=av/real(ns)
      sd=sqrt(sd/real(ns)-av*av)
*     write(3,*) 'The number of records on ', sfile,'=',ns
*     write(3,'(4x,a6,2x,f10.8)') 'F-BAR=',av
*     write(3,'(4x,a6,2x,f10.8)') 'S.D. =',sd
      close(3)
      stop
      end


*------search subroutine-----------------
      subroutine search(ida)
      parameter (n=5000000,nk=500000)
      integer id(3,n),pick(3,nk)
      common /pinf/id,nrec,pick,ll
      do 60 ij=ll,1,-1
        if(ida.eq.pick(1,ij)) then
          pick(1,ij)=0
          ll=ll+1
          pick(1,ll)=ida
          pick(2,ll)=pick(2,ij)
          pick(3,ll)=pick(3,ij)
          go to 666
        end if
60    continue
      i=1
      j=nrec
      do  while(i.lt.j)
        k=(i+j)/2
        if(id(1,k).eq.ida) then
         go to 888
        else if(id(1,k).lt.ida) then
          i=k+1
        else
          j=k
        end if
      end do
888   continue
      if(id(1,k).eq.ida) then
          ll=ll+1
          pick(1,ll)=ida
          pick(2,ll)=id(2,k)
          pick(3,ll)=id(3,K)
      else
        ll=ll+1
          pick(1,ll)=ida
          pick(2,ll)=0
          pick(3,ll)=0
      end if
666   continue
      return
      end
*---------------------------------------

